# HierarchyBuilder.Type (ARX API Documentation)

org.deidentifier.arx.aggregates

## Enum HierarchyBuilder.Type

- java.lang.Object
- - java.lang.Enum<HierarchyBuilder.Type>
  - - org.deidentifier.arx.aggregates.HierarchyBuilder.Type

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<HierarchyBuilder.Type>
  Enclosing class:
    HierarchyBuilder<T>

      public static enum HierarchyBuilder.Type
      extends java.lang.Enum<HierarchyBuilder.Type>

  The three types of builders.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `INTERVAL_BASED` Interval-based hierarchy
    `ORDER_BASED` Order-based hierarchy
    `REDACTION_BASED` Redaction-based hierarchy

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `toString()`
    `static HierarchyBuilder.Type` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static HierarchyBuilder.Type[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `compareTo, equals, getDeclaringClass, hashCode, name, ordinal, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### INTERVAL_BASED

          public static final HierarchyBuilder.Type INTERVAL_BASED

      Interval-based hierarchy

    - #### ORDER_BASED

          public static final HierarchyBuilder.Type ORDER_BASED

      Order-based hierarchy

    - #### REDACTION_BASED

          public static final HierarchyBuilder.Type REDACTION_BASED

      Redaction-based hierarchy

  - ### Method Detail

    - #### values

          public static HierarchyBuilder.Type[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (HierarchyBuilder.Type c : HierarchyBuilder.Type.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static HierarchyBuilder.Type valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Enum<HierarchyBuilder.Type>`